component-section
  div(slot='title') 📈 Performanceonderzoek
  component-section
    div(slot='title') Begrippenkader
    p.bron
      | Systems Performance
      cite(data-id='6867189/VBGW22DZ', data-label='chapter', data-locator='1')
      cite(data-id='6867189/VBGW22DZ', data-label='chapter', data-locator='2')
      |
      | (optioneel, relevant voor OP)
      cite(data-id='6867189/VBGW22DZ', data-label='section', data-locator='5-5.4')
    // TODO: wat is performance efficiency?
    p
      em.term Profiling
      |
      | is het verzamelen van statistische informatie over voor performanceonderzoek relevante soorten gebeurtenissen terwijl een softwaresysteem loopt.
    ul
      li
        p Gebeurtenissen binnen het systeem
        ul
          li
            p Hoeveel geheugenallocaties
          li
            p Hoeveel threads
          li
            p Hoeveel geheugenruimte in gebruik
          li
            p ...
      li
        p Gebeurtenissen buiten het systeem
        ul
          li
            p Hoeveel keer swapfile aangesproken?
          li
            p Hoeveel threads actief in totaal?
          li
            p Hoeveel dataverkeer?
          li
            p Hoeveel stroomverbruik?
          li
            p ...
    p
      em.term Benchmarking
      |
      | houdt in performance testen in vergelijking met een bepaalde baseline (normniveau) en/of alternatieven.
    p
      | Microbenchmarking betekent dat de computationele taak kortlopend is.
      | Dat is dus zelden een hele use-case of functionele test, maar vaker bijvoorbeeld een unit test of integratietest.
    p
      em.term Performance testing
      |
      | is een verzamelbegrip.
      | Om te
      |
      em testen
      |
      | heb je criteria nodig en een context (zoals de qas’en uit SKA).
      | Je ontwikkelt niet (soms doelloos of prematuur), maar je bent vooral aan het onderzoeken.
  component-section
    div(slot='title') Onderzoeken
    component-section
      div(slot='title') Reikwijdte (onderzoeksprojectgrenzen) en randvoorwaarden
      p
        | De fase in de softwarelevenscyclus waarbinnen je onderzoekt beïnvloedt welke methoden je toe kan passen:
      ul
        li
          p
            em Ontwikkelfase
            | : benchmarking.
        li
          p
            em Onderhoudsfase en operationeel
            | : profiling.
      p
        | Natuurlijk kan je ook beide fases meenemen, als dat binnen je onderzoeksopdracht past.
      p
        em Separation of concerns
        | : besturingssysteem versus de onderzochte softwaresystemen.
      p Welke randvoorwaarden?
      | Ga je uit van bepaalde hardware?
      p
        | Welke constraints (grenzen aan softwaresysteem) gelden?
        | Hieruit kunnen hardware- en besturingssysteemgrenzen volgen.
    component-section
      div(slot='title') Welke componenten onderzoeken
      p
        | Afhankelijk van welke fase van de softwarelevenscyclus je wilt onderzoeken, kan je als aanknopingspunten de volgende zaken nemen:
      ul
        li
          p Ontwikkeling
          ul
            li
              p (Niet-performance) tests
        li
          p Operationeel
          ul
            li
              p Use-cases nabootsen als workload scenario.
              p
                | Networked apps (bijvoorbeeld webapps): profilen en monitoren van (productie)variant.
            li
              p Bouwstraat.
  component-section
    div(slot='title') Performance tests schrijven
    p
      | Kan al met simple timing info
      a(href='https://www.baeldung.com/junit-test-execution-time#intellij%20junit') geproduceerd door bijvoorbeeld het JUnit test framework en/of IDE
      | .
    p
      | Kan nog beter met specifiek benchmarking framework (
      em harness
      | ), zoals
      a(href='http://tutorials.jenkov.com/java-performance/jmh.html') JMH
      | .
      | Voordelen:
    ul
      li
        p
          | Kan optimalisaties door compiler onder controle houden, waardoor ‘nutteloze’ broncode niet weggeoptimaliseerd wordt.
      li
        p Hanteert nauwkeurige timers.
      li
        p
          | Herhaalt metingen automatisch, en geeft relevante statistieken (mediaan bijvoorbeeld).
  component-section
    div(slot='title') Algoritmeanalyse versus andere vormen van performance onderzoek
    ul
      li
        p Abstract versus concreet.
      li
        p
          | Algemene waarheid (fundamenteel onderzoek) versus waarheid onder systeem (praktijkonderzoek).
      li
        p Schaalbaarheid versus exacte prestatie in praktijkscenario.
  component-section
    div(slot='title')
      | Relatie tussen prestatie-efficiëntie (‘performance’) en andere kwaliteitseigenschappen
    ul
      li
        p
          em Schaalbaarheid
          | : algoritmeanalyse nuttig!
      li
        p
          em Onderhoudbaarheid
          | : hoe lang tests duren.
      li
        p
          em Gebruikersvriendelijkheid
          | : als gebruikers te lang moeten wachten denken ze dat ze iets niet goed doen of dat er een probleem is opgetreden.
      li
        p
          em Kosten
          | : hoe inefficiënter hoe meer kosten.
          | Dat tikt aan, zeker in een public cloudomgeving.
  component-section
    div(slot='title') Scenario/workload ontwerpen om te onderzoeken
    p
      | Normale versus extreme scenario’s = gemiddelde geval versus slechtste geval én grootte invoerdata.
    p Data speelt een cruciale rol, zeker bij algoritmeanalyse.
    p Welke grootheid meet je? Geheugen versus looptijd?
    p Referentiedataset (test inputs).
  component-section
    div(slot='title') Resultaten
    p Ruwe meetgegevens versus rapportage.
    p Watervaldiagram.
    p Flame graph.
    p Samenvattende statistieken versus profile (= detailstatistieken).
  component-section
    div(slot='title') Tips
    p Gebruik de performance matras van Gregg.
    ol 
      li Don’t do it.
      li Do it, but don’t do it again.
      li Do it less.
      li Do it later.
      li Do it when they’re not looking.
      li Do it concurrently.
      li Do it more cheaply.
    p
      | Begin met de eenvoudigste performance tests.
      | Beter een compleet onderzoek dan een perfect maar incompleet onderzoek!
    p
      | Neem ook een eventueel
      |
      em frontend
      |
      | (webgebaseerde gebruikersinterface) mee.
      | Verscheidene metrics in de developer tools van browser die te maken hebben met vertragingen in de GUI.
      | Voel je in je onderzoek niet gebonden aan één programmeertaal, zoals waar de backend in geschreven is.
    p
      | Zoek naar gericht naar het gebruik van datastructuren, zeker die waarvan je al weet dat die niet efficiënt zijn (geïmplementeerd).
      | Bijvoorbeeld
      |
      code.lang-java Stack
      |
      | uit de Java standard library.
